[PATCH v7] scripts/config: honor $KBUILD_OUTPUT by default
From: Dmitry Voytik
Date: Tue Oct 06 2026 - 12:12:39 EST
If $KBUILD_OUTPUT is set, use it by default if --file is not passed.
Fix the issue when the script silently updates a stale .config in
the root directory, while the user expects ${KBUILD_OUTPUT}/.config
to be updated.
Handle properly if the config file is a relative path.
The problem can be worked around with --file, but this is easy to miss,
and is inconsistent with how the Makefile and other tools work
(e.g., scripts/diffconfig).
How to reproduce the issue:
make mrproper
export KBUILD_OUTPUT=.out
make defconfig
./scripts/config \
-e CONFIG_UBSAN
Error reported:
grep: .config: No such file or directory
How the patch was tested:
make mrproper
export KBUILD_OUTPUT=.out
make defconfig
grep "CONFIG_UBSAN=y" $KBUILD_OUTPUT/.config || echo "OK"
Test the basic usage:
./scripts/config -e CONFIG_UBSAN
grep "CONFIG_UBSAN=y" $KBUILD_OUTPUT/.config && echo "OK"
Test --refresh picks up correct config file by using $KBUILD_OUTPUT:
./scripts/config -d CONFIG_UBSAN
grep "CONFIG_UBSAN=y" $KBUILD_OUTPUT/.config && echo "FAIL"
./scripts/config --refresh -e CONFIG_UBSAN
grep "CONFIG_UBSAN=y" $KBUILD_OUTPUT/.config && echo "OK"
Test --file takes precedence over $KBUILD_OUTPUT and a relative
path is handled properly:
./scripts/config -d CONFIG_UBSAN
mkdir .out2
cp .out/.config .out2/.my_config
grep "CONFIG_UBSAN=y" .out2/.my_config && echo "FAIL"
./scripts/config --file .out2/.my_config --refresh \
-e CONFIG_UBSAN
grep "CONFIG_UBSAN=y" .out2/.my_config && echo "OK"
ls .out/.out2 && echo "FAIL"
ls .out/.out && echo "FAIL"
Test --file can accept files with hyphen:
./scripts/config -d CONFIG_UBSAN
cp .out/.config -- -my_config
grep "CONFIG_UBSAN=y" -- -my_config && echo "FAIL"
./scripts/config --refresh \
-e CONFIG_UBSAN --file -my_config
grep "CONFIG_UBSAN=y" -- -my_config && echo "OK"
Signed-off-by: Dmitry Voytik <voytikd@xxxxxxxxx>
---
v7:
* Adressed https://sashiko.dev/#/patchset/20261006142337.821859-1-voytikd%40gmail.com
v6:
* Per Nathan Chancellor's suggestions, simplified
* https://lore.kernel.org/lkml/179121581235.2275809.12565811683284940522.b4-review@b4/
v5:
* Per Nathan Chancellor's suggestion, improved handling $FN path by
realpath
* https://lore.kernel.org/lkml/179097210878.309835.10523307262544578337.b4-review@b4/
* Documented the new test scenario in the git commit message
v4:
* Addressed Nicolas Schier's comments - dropped the change how '--refresh'
is handled
* Implemented conversion of $FN to the absolute path which helps with
'--refresh' and relative paths
* Documented testing steps in the commit message
v3:
* Added an example in the commit message how to reproduce the issue
v2:
* Addressed comments by sashiko:
* https://sashiko.dev/#/patchset/20260920064350.17999-1-voytikd%40gmail.com
* use basename when --refresh is used
* remove echo which can be misleading when --file is passed
v1:
* https://lore.kernel.org/all/20260920064350.17999-1-voytikd@xxxxxxxxx/
---
scripts/config | 18 +++++++++++++++---
1 file changed, 15 insertions(+), 3 deletions(-)
diff --git a/scripts/config b/scripts/config
index 32428ea909c2..1e29e449077c 100755
--- a/scripts/config
+++ b/scripts/config
@@ -130,13 +130,15 @@ on_exit() {
trap on_exit EXIT
FN=.config
+
+
CMDS=()
while [[ $# -gt 0 ]]; do
if [ "$1" = "--file" ]; then
if [ "$2" = "" ]; then
usage
fi
- FN="$2"
+ FN=$(realpath -q -- "$2" || printf -- "%s\n" "$2")
shift 2
else
CMDS+=("$1")
@@ -144,6 +146,16 @@ while [[ $# -gt 0 ]]; do
fi
done
+# ignore $KBUILD_OUTPUT if "--file" option is present
+if [[ "$FN" == ".config" && -n "$KBUILD_OUTPUT" ]]; then
+ if [[ ! -d "$KBUILD_OUTPUT" ]]; then
+ echo "KBUILD_OUTPUT is set but does not exist or is not a " >&2
+ echo "directory. Create it before running $myname." >&2
+ exit 1
+ fi
+ FN=$(realpath -- "$KBUILD_OUTPUT")/"$FN"
+fi
+
set -- "${CMDS[@]}"
if [ "$1" = "" ] ; then
usage
@@ -200,7 +212,7 @@ while [ "$1" != "" ] ; do
;;
--state|-s)
- if grep -q "# ${CONFIG_}$ARG is not set" $FN ; then
+ if grep -q "# ${CONFIG_}$ARG is not set" "$FN" ; then
echo n
else
V="$(grep "^${CONFIG_}$ARG=" $FN)"
@@ -229,7 +241,7 @@ while [ "$1" != "" ] ; do
;;
--refresh)
- yes "" | make oldconfig KCONFIG_CONFIG=$FN
+ yes "" | make oldconfig KCONFIG_CONFIG="$FN"
;;
*)
--
2.55.0